/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "red_extra.override"
#include <Python.h>

#define NO_IMPORT_PYGOBJECT
#include "pygobject.h"
#include "redlistmodel.h"
#include "redlistview.h"
#line 15 "red_extra.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkTreeModel_Type;
#define PyGtkTreeModel_Type (*_PyGtkTreeModel_Type)
static PyTypeObject *_PyGtkTreeView_Type;
#define PyGtkTreeView_Type (*_PyGtkTreeView_Type)
static PyTypeObject *_PyGtkCellRenderer_Type;
#define PyGtkCellRenderer_Type (*_PyGtkCellRenderer_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyRedListModel_Type;
PyTypeObject PyRedListView_Type;


/* ----------- RedListModel ----------- */

static int
_wrap_red_list_model_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":RedListModel.__init__", kwlist))
        return -1;
    self->obj = (GObject *)red_list_model_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create RedListModel object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_red_list_model_set_list(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pylist", NULL };
    PyObject *pylist;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:RedListModel.set_list", kwlist, &pylist))
        return NULL;
    red_list_model_set_list(RED_LIST_MODEL(self->obj), pylist);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_red_list_model_get_list_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "row_num", NULL };
    int row_num;
    PyObject *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:RedListModel.get_list_item", kwlist, &row_num))
        return NULL;
    ret = red_list_model_get_list_item(RED_LIST_MODEL(self->obj), row_num);
    if (!ret) ret = Py_None;
    Py_INCREF(ret);
    return ret;
}

static PyObject *
_wrap_red_list_model_length(PyGObject *self)
{
    int ret;

    ret = red_list_model_length(RED_LIST_MODEL(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_red_list_model_add_column(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pylist", "type", NULL };
    PyObject *pylist, *py_type = NULL;
    int ret;
    GType type;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OO:RedListModel.add_column", kwlist, &pylist, &py_type))
        return NULL;
    if ((type = pyg_type_from_object(py_type)) == 0)
        return NULL;
    ret = red_list_model_add_column(RED_LIST_MODEL(self->obj), pylist, type);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_red_list_model_row_changed(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "row_number", NULL };
    int row_number;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:RedListModel.row_changed", kwlist, &row_number))
        return NULL;
    red_list_model_row_changed(RED_LIST_MODEL(self->obj), row_number);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_red_list_model_set_filter_magic(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filter_callback", NULL };
    PyObject *filter_callback;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:RedListModel.set_filter_magic", kwlist, &filter_callback))
        return NULL;
    red_list_model_set_filter_magic(RED_LIST_MODEL(self->obj), filter_callback);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_red_list_model_set_sort_magic(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "sort_callback", "reverse_sort", NULL };
    PyObject *sort_callback;
    int reverse_sort;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "Oi:RedListModel.set_sort_magic", kwlist, &sort_callback, &reverse_sort))
        return NULL;
    red_list_model_set_sort_magic(RED_LIST_MODEL(self->obj), sort_callback, reverse_sort);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyRedListModel_methods[] = {
    { "set_list", (PyCFunction)_wrap_red_list_model_set_list, METH_VARARGS|METH_KEYWORDS },
    { "get_list_item", (PyCFunction)_wrap_red_list_model_get_list_item, METH_VARARGS|METH_KEYWORDS },
    { "length", (PyCFunction)_wrap_red_list_model_length, METH_NOARGS },
    { "add_column", (PyCFunction)_wrap_red_list_model_add_column, METH_VARARGS|METH_KEYWORDS },
    { "row_changed", (PyCFunction)_wrap_red_list_model_row_changed, METH_VARARGS|METH_KEYWORDS },
    { "set_filter_magic", (PyCFunction)_wrap_red_list_model_set_filter_magic, METH_VARARGS|METH_KEYWORDS },
    { "set_sort_magic", (PyCFunction)_wrap_red_list_model_set_sort_magic, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyRedListModel_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "red_extra.ListModel",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyRedListModel_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_red_list_model_new,		/* tp_init */
};



/* ----------- RedListView ----------- */

static int
_wrap_red_list_view_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":RedListView.__init__", kwlist))
        return -1;
    self->obj = (GObject *)red_list_view_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create RedListView object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_red_list_view_add_spanner_with_background(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "row_number", "column_start", "column_end", "cell_renderer", "bg_color", NULL };
    int row_number, column_start, column_end;
    PyGObject *cell_renderer;
    GdkColor *bg_color = NULL;
    PyObject *py_bg_color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiiO!O:RedListView.add_spanner_with_background", kwlist, &row_number, &column_start, &column_end, &PyGtkCellRenderer_Type, &cell_renderer, &py_bg_color))
        return NULL;
    if (pyg_boxed_check(py_bg_color, GDK_TYPE_COLOR))
        bg_color = pyg_boxed_get(py_bg_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "bg_color should be a GdkColor");
        return NULL;
    }
    red_list_view_add_spanner_with_background(RED_LIST_VIEW(self->obj), row_number, column_start, column_end, GTK_CELL_RENDERER(cell_renderer->obj), bg_color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_red_list_view_add_spanner(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "row_number", "column_start", "column_end", "cell_renderer", NULL };
    int row_number, column_start, column_end;
    PyGObject *cell_renderer;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiiO!:RedListView.add_spanner", kwlist, &row_number, &column_start, &column_end, &PyGtkCellRenderer_Type, &cell_renderer))
        return NULL;
    red_list_view_add_spanner(RED_LIST_VIEW(self->obj), row_number, column_start, column_end, GTK_CELL_RENDERER(cell_renderer->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyRedListView_methods[] = {
    { "add_spanner_with_background", (PyCFunction)_wrap_red_list_view_add_spanner_with_background, METH_VARARGS|METH_KEYWORDS },
    { "add_spanner", (PyCFunction)_wrap_red_list_view_add_spanner, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyRedListView_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "red_extra.ListView",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyRedListView_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_red_list_view_new,		/* tp_init */
};



/* ----------- functions ----------- */

PyMethodDef red_functions[] = {
    { NULL, NULL, 0 }
};

/* intialise stuff extension classes */
void
red_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGtkTreeModel_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "TreeModel");
        _PyGtkTreeView_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "TreeView");
        _PyGtkCellRenderer_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "CellRenderer");
    } else {
        Py_FatalError("could not import gtk");
        return;
    }


#line 336 "red_extra.c"
    pygobject_register_class(d, "RedListModel", RED_TYPE_LIST_MODEL, &PyRedListModel_Type, Py_BuildValue("(OO)", &PyGObject_Type, &PyGtkTreeModel_Type));
    pygobject_register_class(d, "RedListView", RED_TYPE_LIST_VIEW, &PyRedListView_Type, Py_BuildValue("(O)", &PyGtkTreeView_Type));
}
